#include <bits/stdc++.h>

#define debug(x) cerr << #x << ": " << x << endl

#define all(x) (x).begin(), (x).end()
#define eb emplace_back
#define mp make_pair
#define pb push_back
#define sz(x) ((int)(x).size())

using namespace std;

using ll = long long;
using pi = pair<int, int>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pi>;
using vvi = vector<vi>;

const int BIG = 1e9;
const ll INF = 1e18;

void solve() {
    int n, q;
    cin >> n >> q;
    vi p(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
    }
    vi s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vvi gr(n);
    for (int i = 1; i < n; ++i) {
        gr[p[i]].pb(i);
    }
    vi cnt(n, 0);
    function<int(int)> dfs1 = [&] (int u) {
        cnt[u] = 1;
        for (int v : gr[u]) {
            cnt[u] += dfs1(v);
        }
        return cnt[u];
    };
    dfs1(0);
    int timer = 0;
    vi tin(n), head(n);
    function<void(int, int)> dfs2 = [&] (int u, int h) {
        tin[u] = timer++;
        head[u] = h;
        int bst = -1;
        for (int v : gr[u]) {
            if (bst == -1 || cnt[v] > cnt[bst]) {
                bst = v;
            }
        }
        if (bst != -1) {
            dfs2(bst, h);
        }
        for (int v : gr[u]) {
            if (v != bst) {
                dfs2(v, v);
            }
        }
    };
    dfs2(0, 0);
    vpi t(4 * n, mp(0, 0));
    auto push = [&] (int i, int tl, int tr) {
        t[i].first += t[i].second;
        if (tr - tl > 1) {
            t[2 * i + 1].second += t[i].second;
            t[2 * i + 2].second += t[i].second;
        }
        t[i].second = 0;
    };
    function<void(int, int, int, int, int)> add = [&] (int i, int tl, int tr, int l, int r) {
        push(i, tl, tr);
        if (r <= tl || tr <= l) {
            return;
        }
        if (l <= tl && tr <= r) {
            t[i].second++;
            push(i, tl, tr);
            return;
        }
        int tm = (tl + tr) / 2;
        add(2 * i + 1, tl, tm, l, r);
        add(2 * i + 2, tm, tr, l, r);
        t[i].first = max(t[2 * i + 1].first, t[2 * i + 2].first);
    };
    function<int(int, int, int, int, int)> get = [&] (int i, int tl, int tr, int l, int r) {
        if (r <= tl || tr <= l || l >= r) {
            return 0;
        }
        push(i, tl, tr);
        if (l <= tl && tr <= r) {
            return t[i].first;
        }
        int tm = (tl + tr) / 2;
        return max(get(2 * i + 1, tl, tm, l, r), get(2 * i + 2, tm, tr, l, r));
    };
    auto add_hld = [&] (int v) {
        while (head[v] != 0) {
            add(0, 0, n, tin[head[v]], tin[v] + 1);
            v = p[head[v]];
        }
        add(0, 0, n, 0, tin[v] + 1);
    };
    auto get_hld = [&] (int v) {
        int ans = 0, lst = n;
        while (head[v] != 0) {
            ans = max(ans, get(0, 0, n, tin[v] + 1, lst));
            lst = tin[head[v]];
            v = p[head[v]];
        }
        ans = max(ans, get(0, 0, n, tin[v] + 1, lst));
        return ans;
    };
    vi ans(n, 0);
    priority_queue<pi, vpi> qu;
    qu.push(mp(s[0], 0));
    int tm = 0;
    while (!qu.empty()) {
        int u = qu.top().second;
        qu.pop();
        ans[u] = tm - get_hld(u);
        ++tm;
        add_hld(u);
        for (int v : gr[u]) {
            qu.push(mp(s[v], v));
        }
    }
    while (q--) {
        int v;
        cin >> v;
        --v;
        cout << ans[v] << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
